package com.company.showpdfissue.view.blank;


import com.company.showpdfissue.view.main.MainView;

import com.vaadin.flow.component.ClickEvent;
import com.vaadin.flow.component.Unit;
import com.vaadin.flow.router.Route;
import com.vaadin.flow.server.StreamRegistration;
import com.vaadin.flow.server.StreamResource;
import com.vaadin.flow.server.VaadinSession;
import io.jmix.flowui.component.image.JmixImage;
import io.jmix.flowui.kit.component.button.JmixButton;
import io.jmix.flowui.view.*;
import org.apache.commons.io.FileUtils;
import org.springframework.util.ResourceUtils;

import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;

@Route(value = "blank-view", layout = MainView.class)
@ViewController("example_BlankView")
@ViewDescriptor("blank-view.xml")
public class BlankView extends StandardView {
    @ViewComponent
    private JmixImage<?> pdfImage;


    @Subscribe("refreshBtn")
    public void onRefreshBtnClick(final ClickEvent<JmixButton> event) throws IOException {
        /*this.pdfImage.setVisible(false);
        Path pdfPath = Paths.get("pdf_files/file_4Mb.pdf");
        //Path pdfPath = Paths.get("pdf_files/file-example_PDF_1MB.pdf");
        byte[] pdf  = Files.readAllBytes(pdfPath);
        ByteArrayInputStream in = new ByteArrayInputStream(pdf);
        StreamResource resource = new StreamResource("test.pdf", () -> in);
        this.pdfImage.setSrc(resource);
        this.pdfImage.setHeight(100, Unit.PIXELS);
        this.pdfImage.setWidth(400, Unit.PIXELS);
        this.pdfImage.setVisible(true);*/

        //String filePath = "pdf_files/file_4Mb.pdf";
        String filePath = "file_4Mb.pdf";
        File file = ResourceUtils.getFile(filePath);
        ByteArrayInputStream byteArrayInputStream = new ByteArrayInputStream(FileUtils.readFileToByteArray(file));
        final StreamResource resource = new StreamResource(filePath,() -> byteArrayInputStream);
        final StreamRegistration registration = VaadinSession.getCurrent().getResourceRegistry().registerResource(resource);
        pdfImage.setSrc(registration.getResourceUri().toString());
    }
}